function log(message) {
  // Application.sharedInstance().alert(message);
  Application.sharedInstance().showHUD(message, self.window, 2);
}

JSB.newAddon = function (mainPath) {
  var newAddonClass = JSB.defineClass('CommentRemover : JSExtension', /*Instance members*/ {
    //Window initialize
    sceneWillConnect: function () {},
    //Window disconnect
    sceneDidDisconnect: function () {
      self.htmlController.removeFromParentViewController();
      Application.sharedInstance().unregsiterHtmlCommentEditor('CommentRemover');
      Application.sharedInstance().unregsiterHtmlCommentEditor('CommentsRemover');
    },
    //Window resign active
    sceneWillResignActive: function () {},
    //Window become active
    sceneDidBecomeActive: function () {},
    notebookWillOpen: function (notebookid) {
      var removeFunc = function (html, text, respath, retfunc) {
        try {
          // log(Application.sharedInstance().studyController(self.window).readerController.currentDocumentController.focusNote.noteTitle);
          if (Application.sharedInstance().studyController(self.window).notebookController.focusNote == undefined)
          {
            log("Only work if you select a node from nodemap");
            return;
          }
          var note = Application.sharedInstance().studyController(self.window).notebookController.focusNote;
          var timerCount = 0;
          NSTimer.scheduledTimerWithTimeInterval(1, true, function (timer) {
            for (var i = 0; i < note.comments.length; i++) {
              note.removeCommentByIndex(i);
            }
            Database.sharedInstance().setNotebookSyncDirty(note.notebookId);
            NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('RefreshAfterDBChange', self, {
              topicid: note.notebookId
            });
            timerCount++;
            if (timerCount >= 4) {
              timer.invalidate();
            }
          });
        } catch (err) {
          log(err);
        }
      };
      var removeChildrenFunc = function (html, text, respath, retfunc, note) {
        try {
          if (Application.sharedInstance().studyController(self.window).notebookController.focusNote == undefined)
          {
            log("Only work if you select a node from nodemap");
            return;
          }
          var needTimer = false;
          if (note == undefined)
          {
            needTimer = true;
            note = Application.sharedInstance().studyController(self.window).notebookController.focusNote;
          }

          if (note.comments.length > 1) needTimer = true;
          if (note.comments.length == 1 && needTimer == false)
          {
            for (var i = 0; i < note.comments.length; i++) {
              note.removeCommentByIndex(i);
            }
          }

          if (needTimer)
          {
            var timerCount = 0;
            NSTimer.scheduledTimerWithTimeInterval(1, true, function (timer) {
  
              for (var i = 0; i < note.comments.length; i++) {
                note.removeCommentByIndex(i);
              }
              
              Database.sharedInstance().setNotebookSyncDirty(note.notebookId);
              NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('RefreshAfterDBChange', self, {
                topicid: note.notebookId
              });
              timerCount++;
              if (timerCount >= 3) {
                timer.invalidate();
              }
            });
          }
  
          for (var i = 0; i < note.childNotes.length; i++)
          {
            removeChildrenFunc(null, null, null, null, note.childNotes[i]);
          }
        } catch (err) {
          log(err);
        }
      };
      var image = UIImage.imageWithData(NSData.dataWithContentsOfFile(mainPath + '/x-circle.png'), 2);
      Application.sharedInstance().regsiterHtmlCommentEditor({
        title: "Remove comments",
        image: image
      }, removeFunc, null, 'CommentRemover');

      var image = UIImage.imageWithData(NSData.dataWithContentsOfFile(mainPath + '/x.png'), 2);
      Application.sharedInstance().regsiterHtmlCommentEditor({
        title: "Remove children's comments",
        image: image
      }, removeChildrenFunc, null, 'CommentsRemover');

    },
    notebookWillClose: function (notebookid) {},
    documentDidOpen: function (docmd5) {},
    documentWillClose: function (docmd5) {},
    controllerWillLayoutSubviews: function (controller) {},
  }, /*Class members*/ {
    addonDidConnect: function () {},
    addonWillDisconnect: function () {},
    applicationWillEnterForeground: function () {},
    applicationDidEnterBackground: function () {},
    applicationDidReceiveLocalNotification: function (notify) {},
  });
  return newAddonClass;
};